package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryProductStatusDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryProductStatusDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionaryProductStatusDao;
import com.friday.custody.entity.DataDictionaryProductStatusEntity;
import com.friday.custody.service.basicService.DataDictionaryProductStatusService;
import org.springframework.util.CollectionUtils;


@Service("dataDictionaryProductStatusService")
public class DataDictionaryProductStatusServiceImpl extends ServiceImpl<DataDictionaryProductStatusDao, DataDictionaryProductStatusEntity>
        implements DataDictionaryProductStatusService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryProductStatusEntity> page = this.page(
                new Query<DataDictionaryProductStatusEntity>().getPage(params),
                new QueryWrapper<DataDictionaryProductStatusEntity>()
        );

        return new PageUtils(page);
    }


    @Autowired
    private DataDictionaryProductStatusDetailsService detailsService;
    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryProductStatusEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryProductStatusDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryProductStatusDetailsEntity::getOriginValue, DataDictionaryProductStatusDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryProductStatusEntity::getId, DataDictionaryProductStatusEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryProductStatusDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryProductStatusEntity 查询失败！");
        }
        return result;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionaryProductStatusEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryProductStatusEntity::getKeyStr
                            ,DataDictionaryProductStatusEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}